﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web.UI.WebControls;
using System.Web.UI;

namespace SimpleMap
{
    public class CustomMapControl : Panel
    {
        public CustomMapControl()
        {
        }

        public CustomMapControl(string imagePath)
        {
            this.ImagePath = imagePath;
        }

        public string ImagePath
        {
            get;
            set;
        }

        public string Text
        {
            get;
            set;
        }

        public int Width
        {
            get;
            set;
        }

        public int Height
        {
            get;
            set;
        }

        public string PageName
        {
            get
            {
                string pageName = Page.Request.FilePath;
                pageName = pageName.Substring(pageName.LastIndexOf('/') + 1);

                if (pageName.IndexOf('.') != -1)
                    pageName = pageName.Remove(pageName.IndexOf('.'));

                return pageName;
            }
        }

        protected override void LoadViewState(object savedState)
        {
            ImagePath = Page.Session[PageName + ClientID + "ImagePath"].ToString();
            object width = Page.Session[PageName + ClientID + "Width"];
            object height = Page.Session[PageName + ClientID + "Height"];
            Width = width == null ? 0 : (int)width;
            Height = height == null ? 0 : (int)height;

            base.LoadViewState(savedState);
        }

        protected override void Render(HtmlTextWriter writer)
        {
            //base.Render(writer);

            StringBuilder htmlBuild = new StringBuilder();
            htmlBuild.Append(string.Format("<div id='{0}'>", this.ClientID))
                .Append(string.Format("<img src='{0}' width='{1}' height='{2}'></img>", string.Format("ImageHandler.axd?pageName={0}&id={1}&EXTRA={2}", PageName, ClientID, DateTime.Now.ToOADate()), this.Width, this.Height))
                .Append("</div>");

            writer.Write(htmlBuild.ToString());
        }

        protected override object SaveViewState()
        {
            Page.Session[PageName + ClientID + "ImagePath"] = ImagePath;
            Page.Session[PageName + ClientID + "Width"] = Width;
            Page.Session[PageName + ClientID + "Height"] = Height;

            return base.SaveViewState();
        }
    }
}
