﻿using System;
using System.Web;
using System.Drawing;
using System.IO;
using System.Drawing.Imaging;
using System.Web.SessionState;

namespace SimpleMap
{
    public class ImageHandler : IHttpHandler, IReadOnlySessionState
    {
        /// <summary>
        /// You will need to configure this handler in the web.config file of your 
        /// web and register it with IIS before being able to use it. For more information
        /// see the following link: http://go.microsoft.com/?linkid=8101007
        /// </summary>
        #region IHttpHandler Members

        public bool IsReusable
        {
            // Return false in case your Managed Handler cannot be reused for another request.
            // Usually this would be false in case you have some state information preserved per request.
            get { return true; }
        }

        public void ProcessRequest(HttpContext context)
        {
            //write your handler implementation here.

            string pagename = context.Request.Params["pageName"];
            string id = context.Request.Params["id"];

            string ImagePath = context.Session[pagename + id + "ImagePath"].ToString();
            object width = context.Session[pagename + id + "Width"];
            object height = context.Session[pagename + id + "Height"];
            int Width = width == null ? 0 : (int)width;
            int Height = height == null ? 0 : (int)height;

            Bitmap bmp = new Bitmap(Width, Height);
            Graphics g = Graphics.FromImage(bmp);

            Bitmap drawnImage = new Bitmap(ImagePath);
            g.DrawImage(drawnImage, new Rectangle(0, 0, Width, Height));

            MemoryStream stream = new MemoryStream();
            bmp.Save(stream, ImageFormat.Png);

            context.Response.Clear();
            context.Response.BinaryWrite(stream.ToArray());
        }

        #endregion
    }
}
